diff --git a/src/charts/axis/chartaxiselement2.cpp b/src/charts/axis/chartaxiselement2.cpp
index 2b47a2ee..871b9a82 100644
--- a/src/charts/axis/chartaxiselement2.cpp
+++ b/src/charts/axis/chartaxiselement2.cpp
@@ -55,35 +55,34 @@ public:
 };
 static StaticLabelFormatMatcherDeleter staticLabelFormatMatcherDeleter;
 
-ChartAxisElement2::ChartAxisElement2(QAbstractAxis *axis, QGraphicsItem *item, bool intervalAxis)
+ChartAxisElement2::ChartAxisElement2(QAbstractAxis *axis, QQuickItem *item, bool intervalAxis)
     : ChartElement2(item),
       m_axis(axis),
       m_animation(0),
-      m_grid(new QGraphicsItemGroup(item)),
-      m_arrow(new QGraphicsItemGroup(item)),
-      m_minorGrid(new QGraphicsItemGroup(item)),
-      m_minorArrow(new QGraphicsItemGroup(item)),
-      m_shades(new QGraphicsItemGroup(item)),
-      m_labels(new QGraphicsItemGroup(item)),
-      m_title(new QGraphicsTextItem(item)),
+//      m_grid(new QQuickItemGroup(item)),
+//      m_arrow(new QQuickItemGroup(item)),
+//      m_minorGrid(new QQuickItemGroup(item)),
+//      m_minorArrow(new QQuickItemGroup(item)),
+//      m_shades(new QQuickItemGroup(item)),
+//      m_labels(new QQuickItemGroup(item)),
+//      m_title(new QGraphicsTextItem(item)),
       m_intervalAxis(intervalAxis)
-
 {
     //initial initialization
-    m_arrow->setHandlesChildEvents(false);
-    m_arrow->setZValue(ChartPresenter2::AxisZValue);
-    m_minorArrow->setHandlesChildEvents(false);
-    m_minorArrow->setZValue(ChartPresenter2::AxisZValue);
-    m_labels->setZValue(ChartPresenter2::AxisZValue);
-    m_shades->setZValue(ChartPresenter2::ShadesZValue);
-    m_grid->setZValue(ChartPresenter2::GridZValue);
-    m_minorGrid->setZValue(ChartPresenter2::GridZValue);
-    m_title->setZValue(ChartPresenter2::GridZValue);
-    m_title->document()->setDocumentMargin(ChartPresenter2::textMargin());
+//    m_arrow->setHandlesChildEvents(false);
+//    m_arrow->setZValue(ChartPresenter2::AxisZValue);
+//    m_minorArrow->setHandlesChildEvents(false);
+//    m_minorArrow->setZValue(ChartPresenter2::AxisZValue);
+//    m_labels->setZValue(ChartPresenter2::AxisZValue);
+//    m_shades->setZValue(ChartPresenter2::ShadesZValue);
+//    m_grid->setZValue(ChartPresenter2::GridZValue);
+//    m_minorGrid->setZValue(ChartPresenter2::GridZValue);
+//    m_title->setZValue(ChartPresenter2::GridZValue);
+//    m_title->document()->setDocumentMargin(ChartPresenter2::textMargin());
     handleVisibleChanged(axis->isVisible());
     connectSlots();
 
-    setFlag(QGraphicsItem::ItemHasNoContents, true);
+    setFlag(QQuickItem::ItemHasContents, false);
 }
 
 ChartAxisElement2::~ChartAxisElement2()
@@ -133,123 +132,123 @@ void ChartAxisElement2::connectSlots()
 
 void ChartAxisElement2::handleArrowVisibleChanged(bool visible)
 {
-    m_arrow->setVisible(visible);
+//    m_arrow->setVisible(visible);
 }
 
 void ChartAxisElement2::handleMinorArrowVisibleChanged(bool visible)
 {
-    m_minorArrow->setVisible(visible);
+//    m_minorArrow->setVisible(visible);
 }
 
 void ChartAxisElement2::handleGridVisibleChanged(bool visible)
 {
-    m_grid->setVisible(visible);
+//    m_grid->setVisible(visible);
 }
 
 void ChartAxisElement2::handleMinorGridVisibleChanged(bool visible)
 {
-    m_minorGrid->setVisible(visible);
+//    m_minorGrid->setVisible(visible);
 }
 
 void ChartAxisElement2::handleLabelsPositionChanged()
 {
-    QGraphicsLayoutItem::updateGeometry();
-    presenter()->layout()->invalidate();
+//    QGraphicsLayoutItem::updateGeometry();
+//    presenter()->layout()->invalidate();
 }
 
 void ChartAxisElement2::handleLabelsVisibleChanged(bool visible)
 {
-    QGraphicsLayoutItem::updateGeometry();
-    presenter()->layout()->invalidate();
-    m_labels->setVisible(visible);
+//    QGraphicsLayoutItem::updateGeometry();
+//    presenter()->layout()->invalidate();
+//    m_labels->setVisible(visible);
 }
 
 void ChartAxisElement2::handleShadesVisibleChanged(bool visible)
 {
-    m_shades->setVisible(visible);
+//    m_shades->setVisible(visible);
 }
 
 void ChartAxisElement2::handleTitleVisibleChanged(bool visible)
 {
-    QGraphicsLayoutItem::updateGeometry();
-    presenter()->layout()->invalidate();
-    m_title->setVisible(visible);
+//    QGraphicsLayoutItem::updateGeometry();
+//    presenter()->layout()->invalidate();
+//    m_title->setVisible(visible);
 }
 
 void ChartAxisElement2::handleLabelsAngleChanged(int angle)
 {
-    foreach (QGraphicsItem *item, m_labels->childItems())
-        item->setRotation(angle);
+//    foreach (QQuickItem *item, m_labels->childItems())
+//        item->setRotation(angle);
 
-    QGraphicsLayoutItem::updateGeometry();
-    presenter()->layout()->invalidate();
+//    QGraphicsLayoutItem::updateGeometry();
+//    presenter()->layout()->invalidate();
 }
 
 void ChartAxisElement2::handleLabelsBrushChanged(const QBrush &brush)
 {
-    foreach (QGraphicsItem *item, m_labels->childItems())
-        static_cast<QGraphicsTextItem *>(item)->setDefaultTextColor(brush.color());
+//    foreach (QQuickItem *item, m_labels->childItems())
+//        static_cast<QGraphicsTextItem *>(item)->setDefaultTextColor(brush.color());
 }
 
 void ChartAxisElement2::handleLabelsFontChanged(const QFont &font)
 {
-    foreach (QGraphicsItem *item, m_labels->childItems())
-        static_cast<QGraphicsTextItem *>(item)->setFont(font);
-    QGraphicsLayoutItem::updateGeometry();
-    presenter()->layout()->invalidate();
+//    foreach (QQuickItem *item, m_labels->childItems())
+//        static_cast<QGraphicsTextItem *>(item)->setFont(font);
+//    QGraphicsLayoutItem::updateGeometry();
+//    presenter()->layout()->invalidate();
 }
 
 void ChartAxisElement2::handleTitleTextChanged(const QString &title)
 {
-    QGraphicsLayoutItem::updateGeometry();
-    presenter()->layout()->invalidate();
-    if (title.isEmpty() || !m_title->isVisible())
-        m_title->setHtml(title);
+//    QGraphicsLayoutItem::updateGeometry();
+//    presenter()->layout()->invalidate();
+//    if (title.isEmpty() || !m_title->isVisible())
+//        m_title->setHtml(title);
 }
 
 void ChartAxisElement2::handleTitleBrushChanged(const QBrush &brush)
 {
-    m_title->setDefaultTextColor(brush.color());
+//    m_title->setDefaultTextColor(brush.color());
 }
 
 void ChartAxisElement2::handleTitleFontChanged(const QFont &font)
 {
-    if (m_title->font() != font) {
-        m_title->setFont(font);
-        QGraphicsLayoutItem::updateGeometry();
-        presenter()->layout()->invalidate();
-    }
+//    if (m_title->font() != font) {
+//        m_title->setFont(font);
+//        QGraphicsLayoutItem::updateGeometry();
+//        presenter()->layout()->invalidate();
+//    }
 }
 
 void ChartAxisElement2::handleVisibleChanged(bool visible)
 {
     setVisible(visible);
-    if (!visible) {
-        m_grid->setVisible(visible);
-        m_arrow->setVisible(visible);
-        m_minorGrid->setVisible(visible);
-        m_minorArrow->setVisible(visible);
-        m_shades->setVisible(visible);
-        m_labels->setVisible(visible);
-        m_title->setVisible(visible);
-    } else {
-        m_grid->setVisible(axis()->isGridLineVisible());
-        m_arrow->setVisible(axis()->isLineVisible());
-        m_minorGrid->setVisible(axis()->isMinorGridLineVisible());
-        m_minorArrow->setVisible(axis()->isLineVisible());
-        m_shades->setVisible(axis()->shadesVisible());
-        m_labels->setVisible(axis()->labelsVisible());
-        m_title->setVisible(axis()->isTitleVisible());
-    }
-    if (presenter()) {
-        if (visible) {
-            QSizeF before = effectiveSizeHint(Qt::PreferredSize);
-            QSizeF after = sizeHint(Qt::PreferredSize);
-            if (before != after)
-                QGraphicsLayoutItem::updateGeometry();
-        }
-        presenter()->layout()->invalidate();
-    }
+//    if (!visible) {
+////        m_grid->setVisible(visible);
+////        m_arrow->setVisible(visible);
+////        m_minorGrid->setVisible(visible);
+////        m_minorArrow->setVisible(visible);
+////        m_shades->setVisible(visible);
+////        m_labels->setVisible(visible);
+//        m_title->setVisible(visible);
+//    } else {
+////        m_grid->setVisible(axis()->isGridLineVisible());
+////        m_arrow->setVisible(axis()->isLineVisible());
+////        m_minorGrid->setVisible(axis()->isMinorGridLineVisible());
+////        m_minorArrow->setVisible(axis()->isLineVisible());
+////        m_shades->setVisible(axis()->shadesVisible());
+////        m_labels->setVisible(axis()->labelsVisible());
+//        m_title->setVisible(axis()->isTitleVisible());
+//    }
+//    if (presenter()) {
+//        if (visible) {
+////            QSizeF before = effectiveSizeHint(Qt::PreferredSize);
+////            QSizeF after = sizeHint(Qt::PreferredSize);
+////            if (before != after)
+////                QGraphicsLayoutItem::updateGeometry();
+//        }
+//        presenter()->layout()->invalidate();
+//    }
 }
 
 void ChartAxisElement2::handleRangeChanged(qreal min, qreal max)
@@ -258,18 +257,18 @@ void ChartAxisElement2::handleRangeChanged(qreal min, qreal max)
     Q_UNUSED(max);
 
     if (!isEmpty()) {
-        QVector<qreal> layout = calculateLayout();
-        updateLayout(layout);
-        QSizeF before = effectiveSizeHint(Qt::PreferredSize);
-        QSizeF after = sizeHint(Qt::PreferredSize);
-
-        if (before != after) {
-            QGraphicsLayoutItem::updateGeometry();
-            // We don't want to call invalidate on layout, since it will change minimum size of
-            // component, which we would like to avoid since it causes nasty flips when scrolling
-            // or zooming, instead recalculate layout and use plotArea for extra space.
-            presenter()->layout()->setGeometry(presenter()->layout()->geometry());
-        }
+//        QVector<qreal> layout = calculateLayout();
+//        updateLayout(layout);
+//        QSizeF before = effectiveSizeHint(Qt::PreferredSize);
+//        QSizeF after = sizeHint(Qt::PreferredSize);
+
+//        if (before != after) {
+//            QGraphicsLayoutItem::updateGeometry();
+//            // We don't want to call invalidate on layout, since it will change minimum size of
+//            // component, which we would like to avoid since it causes nasty flips when scrolling
+//            // or zooming, instead recalculate layout and use plotArea for extra space.
+//            presenter()->layout()->setGeometry(presenter()->layout()->geometry());
+//        }
     }
 }
 
@@ -277,8 +276,8 @@ void ChartAxisElement2::handleReverseChanged(bool reverse)
 {
     Q_UNUSED(reverse);
 
-    QGraphicsLayoutItem::updateGeometry();
-    presenter()->layout()->invalidate();
+//    QGraphicsLayoutItem::updateGeometry();
+//    presenter()->layout()->invalidate();
 }
 
 bool ChartAxisElement2::isEmpty()
diff --git a/src/charts/axis/chartaxiselement2_p.h b/src/charts/axis/chartaxiselement2_p.h
index cd5c676f..245010f7 100644
--- a/src/charts/axis/chartaxiselement2_p.h
+++ b/src/charts/axis/chartaxiselement2_p.h
@@ -43,7 +43,8 @@
 #include <QtCharts/private/qchartglobal_p.h>
 #include <QtCharts/private/chartelement2_p.h>
 #include <private/axisanimation_p.h>
-#include <QtWidgets/QGraphicsItem>
+#include <QQuickItem>
+#include <QQuickPaintedItem>
 #include <QtWidgets/QGraphicsLayoutItem>
 #include <QtCharts/QValueAxis>
 #include <QtGui/QFont>
@@ -53,13 +54,13 @@ QT_CHARTS_BEGIN_NAMESPACE
 class ChartPresenter;
 class QAbstractAxis;
 
-class QT_CHARTS_PRIVATE_EXPORT ChartAxisElement2 : public ChartElement2, public QGraphicsLayoutItem
+class QT_CHARTS_PRIVATE_EXPORT ChartAxisElement2 : public ChartElement2//, public QGraphicsLayoutItem
 {
     Q_OBJECT
 
-    using QGraphicsLayoutItem::setGeometry;
+//    using QGraphicsLayoutItem::setGeometry;
 public:
-    ChartAxisElement2(QAbstractAxis *axis, QGraphicsItem *item, bool intervalAxis = false);
+    ChartAxisElement2(QAbstractAxis *axis, QQuickItem *item, bool intervalAxis = false);
     ~ChartAxisElement2();
 
     virtual QRectF gridGeometry() const = 0;
@@ -115,19 +116,20 @@ protected:
     virtual QVector<qreal> calculateLayout() const = 0;
     virtual void updateLayout(QVector<qreal> &layout) = 0;
 
-    QList<QGraphicsItem *> gridItems() { return m_grid->childItems(); }
-    QList<QGraphicsItem *> minorGridItems() { return m_minorGrid->childItems(); }
-    QList<QGraphicsItem *> labelItems() { return m_labels->childItems(); }
-    QList<QGraphicsItem *> shadeItems() { return m_shades->childItems(); }
-    QList<QGraphicsItem *> arrowItems() { return m_arrow->childItems(); }
-    QList<QGraphicsItem *> minorArrowItems() { return m_minorArrow->childItems(); }
-    QGraphicsTextItem *titleItem() const { return m_title.data(); }
-    QGraphicsItemGroup *gridGroup() { return m_grid.data(); }
-    QGraphicsItemGroup *minorGridGroup() { return m_minorGrid.data(); }
-    QGraphicsItemGroup *labelGroup() { return m_labels.data(); }
-    QGraphicsItemGroup *shadeGroup() { return m_shades.data(); }
-    QGraphicsItemGroup *arrowGroup() { return m_arrow.data(); }
-    QGraphicsItemGroup *minorArrowGroup() { return m_minorArrow.data(); }
+//    QList<QQuickItem *> gridItems() { return m_grid->childItems(); }
+//    QList<QQuickItem *> minorGridItems() { return m_minorGrid->childItems(); }
+//    QList<QQuickItem *> labelItems() { return m_labels->childItems(); }
+//    QList<QQuickItem *> shadeItems() { return m_shades->childItems(); }
+//    QList<QQuickItem *> arrowItems() { return m_arrow->childItems(); }
+//    QList<QQuickItem *> minorArrowItems() { return m_minorArrow->childItems(); }
+    QQuickPaintedItem *titleItem() const { return m_title.data(); }
+    // TODO
+//    QQuickItemGroup *gridGroup() { return m_grid.data(); }
+//    QQuickItemGroup *minorGridGroup() { return m_minorGrid.data(); }
+//    QQuickItemGroup *labelGroup() { return m_labels.data(); }
+//    QQuickItemGroup *shadeGroup() { return m_shades.data(); }
+//    QQuickItemGroup *arrowGroup() { return m_arrow.data(); }
+//    QQuickItemGroup *minorArrowGroup() { return m_minorArrow.data(); }
 
 public Q_SLOTS:
     void handleVisibleChanged(bool visible);
@@ -171,13 +173,13 @@ private:
     QVector<qreal> m_dynamicMinorTickLayout;
     QStringList m_labelsList;
     QRectF m_axisRect;
-    QScopedPointer<QGraphicsItemGroup> m_grid;
-    QScopedPointer<QGraphicsItemGroup> m_arrow;
-    QScopedPointer<QGraphicsItemGroup> m_minorGrid;
-    QScopedPointer<QGraphicsItemGroup> m_minorArrow;
-    QScopedPointer<QGraphicsItemGroup> m_shades;
-    QScopedPointer<QGraphicsItemGroup> m_labels;
-    QScopedPointer<QGraphicsTextItem> m_title;
+//    QScopedPointer<QQuickItemGroup> m_grid;
+//    QScopedPointer<QQuickItemGroup> m_arrow;
+//    QScopedPointer<QQuickItemGroup> m_minorGrid;
+//    QScopedPointer<QQuickItemGroup> m_minorArrow;
+//    QScopedPointer<QQuickItemGroup> m_shades;
+//    QScopedPointer<QQuickItemGroup> m_labels;
+    QScopedPointer<QQuickPaintedItem> m_title;
     bool m_intervalAxis;
 };
 
diff --git a/src/charts/axis/horizontalaxis2.cpp b/src/charts/axis/horizontalaxis2.cpp
index ad590e2e..a6e5c07f 100644
--- a/src/charts/axis/horizontalaxis2.cpp
+++ b/src/charts/axis/horizontalaxis2.cpp
@@ -35,7 +35,7 @@
 
 QT_CHARTS_BEGIN_NAMESPACE
 
-HorizontalAxis2::HorizontalAxis2(QAbstractAxis *axis, QGraphicsItem *item, bool intervalAxis)
+HorizontalAxis2::HorizontalAxis2(QAbstractAxis *axis, QQuickItem *item, bool intervalAxis)
     : CartesianChartAxis2(axis, item, intervalAxis)
 {
 }
